Code

Merge branch 'maint'
[git.git] / git-am.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 USAGE='[--signoff] [--dotest=<dir>] [--utf8] [--binary] [--3way]
6   [--interactive] [--whitespace=<option>] <mbox>...
7   or, when resuming [--skip | --resolved]'
8 . git-sh-setup
9 set_reflog_action am
11 git var GIT_COMMITTER_IDENT >/dev/null || exit
13 stop_here () {
14     echo "$1" >"$dotest/next"
15     exit 1
16 }
18 stop_here_user_resolve () {
19     if [ -n "$resolvemsg" ]; then
20             echo "$resolvemsg"
21             stop_here $1
22     fi
23     cmdline=$(basename $0)
24     if test '' != "$interactive"
25     then
26         cmdline="$cmdline -i"
27     fi
28     if test '' != "$threeway"
29     then
30         cmdline="$cmdline -3"
31     fi
32     if test '.dotest' != "$dotest"
33     then
34         cmdline="$cmdline -d=$dotest"
35     fi
36     echo "When you have resolved this problem run \"$cmdline --resolved\"."
37     echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
39     stop_here $1
40 }
42 go_next () {
43         rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
44                 "$dotest/patch" "$dotest/info"
45         echo "$next" >"$dotest/next"
46         this=$next
47 }
49 cannot_fallback () {
50         echo "$1"
51         echo "Cannot fall back to three-way merge."
52         exit 1
53 }
55 fall_back_3way () {
56     O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
58     rm -fr "$dotest"/patch-merge-*
59     mkdir "$dotest/patch-merge-tmp-dir"
61     # First see if the patch records the index info that we can use.
62     git-apply -z --index-info "$dotest/patch" \
63         >"$dotest/patch-merge-index-info" &&
64     GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
65     git-update-index -z --index-info <"$dotest/patch-merge-index-info" &&
66     GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
67     git-write-tree >"$dotest/patch-merge-base+" ||
68     cannot_fallback "Patch does not record usable index information."
70     echo Using index info to reconstruct a base tree...
71     if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
72         git-apply $binary --cached <"$dotest/patch"
73     then
74         mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
75         mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
76     else
77         cannot_fallback "Did you hand edit your patch?
78 It does not apply to blobs recorded in its index."
79     fi
81     test -f "$dotest/patch-merge-index" &&
82     his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git-write-tree) &&
83     orig_tree=$(cat "$dotest/patch-merge-base") &&
84     rm -fr "$dotest"/patch-merge-* || exit 1
86     echo Falling back to patching base and 3-way merge...
88     # This is not so wrong.  Depending on which base we picked,
89     # orig_tree may be wildly different from ours, but his_tree
90     # has the same set of wildly different changes in parts the
91     # patch did not touch, so recursive ends up canceling them,
92     # saying that we reverted all those changes.
94     eval GITHEAD_$his_tree='"$SUBJECT"'
95     export GITHEAD_$his_tree
96     git-merge-recursive $orig_tree -- HEAD $his_tree || {
97             if test -d "$GIT_DIR/rr-cache"
98             then
99                 git-rerere
100             fi
101             echo Failed to merge in the changes.
102             exit 1
103     }
104     unset GITHEAD_$his_tree
107 prec=4
108 dotest=.dotest sign= utf8= keep= skip= interactive= resolved= binary= ws= resolvemsg=
110 while case "$#" in 0) break;; esac
111 do
112         case "$1" in
113         -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
114         dotest=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
115         -d|--d|--do|--dot|--dote|--dotes|--dotest)
116         case "$#" in 1) usage ;; esac; shift
117         dotest="$1"; shift;;
119         -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
120         --interacti|--interactiv|--interactive)
121         interactive=t; shift ;;
123         -b|--b|--bi|--bin|--bina|--binar|--binary)
124         binary=t; shift ;;
126         -3|--3|--3w|--3wa|--3way)
127         threeway=t; shift ;;
128         -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
129         sign=t; shift ;;
130         -u|--u|--ut|--utf|--utf8)
131         utf8=t; shift ;;
132         -k|--k|--ke|--kee|--keep)
133         keep=t; shift ;;
135         -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
136         resolved=t; shift ;;
138         --sk|--ski|--skip)
139         skip=t; shift ;;
141         --whitespace=*)
142         ws=$1; shift ;;
144         --resolvemsg=*)
145         resolvemsg=$(echo "$1" | sed -e "s/^--resolvemsg=//"); shift ;;
147         --)
148         shift; break ;;
149         -*)
150         usage ;;
151         *)
152         break ;;
153         esac
154 done
156 # If the dotest directory exists, but we have finished applying all the
157 # patches in them, clear it out.
158 if test -d "$dotest" &&
159    last=$(cat "$dotest/last") &&
160    next=$(cat "$dotest/next") &&
161    test $# != 0 &&
162    test "$next" -gt "$last"
163 then
164    rm -fr "$dotest"
165 fi
167 if test -d "$dotest"
168 then
169         case "$#,$skip$resolved" in
170         0,*t*)
171                 # Explicit resume command and we do not have file, so
172                 # we are happy.
173                 : ;;
174         0,)
175                 # No file input but without resume parameters; catch
176                 # user error to feed us a patch from standard input
177                 # when there is already .dotest.  This is somewhat
178                 # unreliable -- stdin could be /dev/null for example
179                 # and the caller did not intend to feed us a patch but
180                 # wanted to continue unattended.
181                 tty -s
182                 ;;
183         *)
184                 false
185                 ;;
186         esac ||
187         die "previous dotest directory $dotest still exists but mbox given."
188         resume=yes
189 else
190         # Make sure we are not given --skip nor --resolved
191         test ",$skip,$resolved," = ,,, ||
192                 die "Resolve operation not in progress, we are not resuming."
194         # Start afresh.
195         mkdir -p "$dotest" || exit
197         git-mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
198                 rm -fr "$dotest"
199                 exit 1
200         }
202         # -b, -s, -u, -k and --whitespace flags are kept for the
203         # resuming session after a patch failure.
204         # -3 and -i can and must be given when resuming.
205         echo "$binary" >"$dotest/binary"
206         echo " $ws" >"$dotest/whitespace"
207         echo "$sign" >"$dotest/sign"
208         echo "$utf8" >"$dotest/utf8"
209         echo "$keep" >"$dotest/keep"
210         echo 1 >"$dotest/next"
211 fi
213 case "$resolved" in
214 '')
215         files=$(git-diff-index --cached --name-only HEAD) || exit
216         if [ "$files" ]; then
217            echo "Dirty index: cannot apply patches (dirty: $files)" >&2
218            exit 1
219         fi
220 esac
222 if test "$(cat "$dotest/binary")" = t
223 then
224         binary=--allow-binary-replacement
225 fi
226 if test "$(cat "$dotest/utf8")" = t
227 then
228         utf8=-u
229 fi
230 if test "$(cat "$dotest/keep")" = t
231 then
232         keep=-k
233 fi
234 ws=`cat "$dotest/whitespace"`
235 if test "$(cat "$dotest/sign")" = t
236 then
237         SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
238                         s/>.*/>/
239                         s/^/Signed-off-by: /'
240                 `
241 else
242         SIGNOFF=
243 fi
245 last=`cat "$dotest/last"`
246 this=`cat "$dotest/next"`
247 if test "$skip" = t
248 then
249         if test -d "$GIT_DIR/rr-cache"
250         then
251                 git-rerere clear
252         fi
253         this=`expr "$this" + 1`
254         resume=
255 fi
257 if test "$this" -gt "$last"
258 then
259         echo Nothing to do.
260         rm -fr "$dotest"
261         exit
262 fi
264 while test "$this" -le "$last"
265 do
266         msgnum=`printf "%0${prec}d" $this`
267         next=`expr "$this" + 1`
268         test -f "$dotest/$msgnum" || {
269                 resume=
270                 go_next
271                 continue
272         }
274         # If we are not resuming, parse and extract the patch information
275         # into separate files:
276         #  - info records the authorship and title
277         #  - msg is the rest of commit log message
278         #  - patch is the patch body.
279         #
280         # When we are resuming, these files are either already prepared
281         # by the user, or the user can tell us to do so by --resolved flag.
282         case "$resume" in
283         '')
284                 git-mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
285                         <"$dotest/$msgnum" >"$dotest/info" ||
286                         stop_here $this
287                 git-stripspace < "$dotest/msg" > "$dotest/msg-clean"
288                 ;;
289         esac
291         GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
292         GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
293         GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
295         if test -z "$GIT_AUTHOR_EMAIL"
296         then
297                 echo "Patch does not have a valid e-mail address."
298                 stop_here $this
299         fi
301         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
303         SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
304         case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
306         case "$resume" in
307         '')
308             if test '' != "$SIGNOFF"
309             then
310                 LAST_SIGNED_OFF_BY=`
311                     sed -ne '/^Signed-off-by: /p' \
312                     "$dotest/msg-clean" |
313                     tail -n 1
314                 `
315                 ADD_SIGNOFF=`
316                     test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
317                     test '' = "$LAST_SIGNED_OFF_BY" && echo
318                     echo "$SIGNOFF"
319                 }`
320             else
321                 ADD_SIGNOFF=
322             fi
323             {
324                 echo "$SUBJECT"
325                 if test -s "$dotest/msg-clean"
326                 then
327                         echo
328                         cat "$dotest/msg-clean"
329                 fi
330                 if test '' != "$ADD_SIGNOFF"
331                 then
332                         echo "$ADD_SIGNOFF"
333                 fi
334             } >"$dotest/final-commit"
335             ;;
336         *)
337                 case "$resolved$interactive" in
338                 tt)
339                         # This is used only for interactive view option.
340                         git-diff-index -p --cached HEAD >"$dotest/patch"
341                         ;;
342                 esac
343         esac
345         resume=
346         if test "$interactive" = t
347         then
348             test -t 0 ||
349             die "cannot be interactive without stdin connected to a terminal."
350             action=again
351             while test "$action" = again
352             do
353                 echo "Commit Body is:"
354                 echo "--------------------------"
355                 cat "$dotest/final-commit"
356                 echo "--------------------------"
357                 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
358                 read reply
359                 case "$reply" in
360                 [yY]*) action=yes ;;
361                 [aA]*) action=yes interactive= ;;
362                 [nN]*) action=skip ;;
363                 [eE]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
364                        action=again ;;
365                 [vV]*) action=again
366                        LESS=-S ${PAGER:-less} "$dotest/patch" ;;
367                 *)     action=again ;;
368                 esac
369             done
370         else
371             action=yes
372         fi
374         if test $action = skip
375         then
376                 go_next
377                 continue
378         fi
380         if test -x "$GIT_DIR"/hooks/applypatch-msg
381         then
382                 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
383                 stop_here $this
384         fi
386         echo
387         echo "Applying '$SUBJECT'"
388         echo
390         case "$resolved" in
391         '')
392                 git-apply $binary --index $ws "$dotest/patch"
393                 apply_status=$?
394                 ;;
395         t)
396                 # Resolved means the user did all the hard work, and
397                 # we do not have to do any patch application.  Just
398                 # trust what the user has in the index file and the
399                 # working tree.
400                 resolved=
401                 changed="$(git-diff-index --cached --name-only HEAD)"
402                 if test '' = "$changed"
403                 then
404                         echo "No changes - did you forget to use 'git add'?"
405                         stop_here_user_resolve $this
406                 fi
407                 unmerged=$(git-ls-files -u)
408                 if test -n "$unmerged"
409                 then
410                         echo "You still have unmerged paths in your index"
411                         echo "did you forget to use 'git add'?"
412                         stop_here_user_resolve $this
413                 fi
414                 apply_status=0
415                 if test -d "$GIT_DIR/rr-cache"
416                 then
417                         git rerere
418                 fi
419                 ;;
420         esac
422         if test $apply_status = 1 && test "$threeway" = t
423         then
424                 if (fall_back_3way)
425                 then
426                     # Applying the patch to an earlier tree and merging the
427                     # result may have produced the same tree as ours.
428                     changed="$(git-diff-index --cached --name-only HEAD)"
429                     if test '' = "$changed"
430                     then
431                             echo No changes -- Patch already applied.
432                             go_next
433                             continue
434                     fi
435                     # clear apply_status -- we have successfully merged.
436                     apply_status=0
437                 fi
438         fi
439         if test $apply_status != 0
440         then
441                 echo Patch failed at $msgnum.
442                 stop_here_user_resolve $this
443         fi
445         if test -x "$GIT_DIR"/hooks/pre-applypatch
446         then
447                 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
448         fi
450         tree=$(git-write-tree) &&
451         echo Wrote tree $tree &&
452         parent=$(git-rev-parse --verify HEAD) &&
453         commit=$(git-commit-tree $tree -p $parent <"$dotest/final-commit") &&
454         echo Committed: $commit &&
455         git-update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
456         stop_here $this
458         if test -x "$GIT_DIR"/hooks/post-applypatch
459         then
460                 "$GIT_DIR"/hooks/post-applypatch
461         fi
463         go_next
464 done
466 rm -fr "$dotest"